<template>
  <v-container fluid>
    <v-row class="text-center">
      <v-col cols="12">
        <v-img
          :src="require('../assets/ow.svg')"
          contain
          height="150"
        />
      </v-col>

      <v-col cols="12">
        <h1 class="display-2 font-weight-bold">
          Overwatch PUGs
        </h1>
      </v-col>

      <v-col v-if="!user" cols="12">
        <v-btn class="ma-2" color="success" @click="loginBtn" :loading="loading" x-large>
          <v-icon left>mdi-battlenet</v-icon> Login to create PUG
        </v-btn>
      </v-col>

      <v-col v-if="user" cols="12">
        <v-btn class="ma-2" tile outlined color="error" @click.native="logout">
          <v-icon left>mdi-battlenet</v-icon> Logout
        </v-btn>
      </v-col>

    </v-row>
  </v-container>
</template>

<script>
import { useState, useActions, useRouter } from '@u3u/vue-hooks';
import { watch } from '@vue/composition-api';

export default {
  name: 'Home',
  setup() {
    const { router } = useRouter();

    const { user, loading } = useState('auth', [
      'user',
      'loading',
    ]);

    const { logout, login } = useActions('auth', [
      'logout',
      'login',
    ]);

    watch(user, () => {
      if (user.value) {
        router.push(`/${user.value.btag.replace('#', '-')}`);
        window.location.reload();
      }
    });

    function loginBtn() {
      login({ url: process.env.VUE_APP_OAUTH_URL, label: 'CreatePUG' });
    }

    return {
      user,
      loading,
      logout,
      loginBtn,
    };
  },
};
</script>
